# swagger-client
## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.languages.PythonClientCodegen
For more information, please visit [https://github.com/uJhin](https://github.com/uJhin)

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com//.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com//.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure API key authorization: Bearer
configuration = swagger_client.Configuration()
configuration.api_key['Authorization'] = 'YOUR_API_KEY'
# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['Authorization'] = 'Bearer'

# create an instance of the API class
api_instance = swagger_client.APIKeyApi(swagger_client.ApiClient(configuration))

try:
    # API 키 리스트 조회
    api_response = api_instance.a_pi_key_info()
    pprint(api_response)
except ApiException as e:
    print("Exception when calling APIKeyApi->a_pi_key_info: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *https://api.upbit.com/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*APIKeyApi* | [**a_pi_key_info**](docs/APIKeyApi.md#a_pi_key_info) | **GET** /api_keys | API 키 리스트 조회
*AccountApi* | [**account_info**](docs/AccountApi.md#account_info) | **GET** /accounts | 전체 계좌 조회
*AccountApi* | [**account_wallet**](docs/AccountApi.md#account_wallet) | **GET** /status/wallet | 입출금 현황
*CandleApi* | [**candle_days**](docs/CandleApi.md#candle_days) | **GET** /candles/days | 시세 캔들 조회 (일 단위)
*CandleApi* | [**candle_minutes**](docs/CandleApi.md#candle_minutes) | **GET** /candles/minutes/{unit} | 시세 캔들 조회 (분 단위)
*CandleApi* | [**candle_month**](docs/CandleApi.md#candle_month) | **GET** /candles/months | 시세 캔들 조회 (월 단위)
*CandleApi* | [**candle_weeks**](docs/CandleApi.md#candle_weeks) | **GET** /candles/weeks | 시세 캔들 조회 (주 단위)
*DepositApi* | [**deposit_coin_address**](docs/DepositApi.md#deposit_coin_address) | **GET** /deposits/coin_address | 개별 입금 주소 조회
*DepositApi* | [**deposit_coin_addresses**](docs/DepositApi.md#deposit_coin_addresses) | **GET** /deposits/coin_addresses | 전체 입금 주소 조회
*DepositApi* | [**deposit_generate_coin_address**](docs/DepositApi.md#deposit_generate_coin_address) | **POST** /deposits/generate_coin_address | 입금 주소 생성 요청
*DepositApi* | [**deposit_info**](docs/DepositApi.md#deposit_info) | **GET** /deposit | 개별 입금 조회
*DepositApi* | [**deposit_info_all**](docs/DepositApi.md#deposit_info_all) | **GET** /deposits | 입금 리스트 조회
*MarketApi* | [**market_info_all**](docs/MarketApi.md#market_info_all) | **GET** /market/all | 마켓 코드 조회
*OrderApi* | [**order_cancel**](docs/OrderApi.md#order_cancel) | **DELETE** /order | 주문 취소 접수
*OrderApi* | [**order_chance**](docs/OrderApi.md#order_chance) | **GET** /orders/chance | 주문 가능 정보
*OrderApi* | [**order_info**](docs/OrderApi.md#order_info) | **GET** /order | 개별 주문 조회
*OrderApi* | [**order_info_all**](docs/OrderApi.md#order_info_all) | **GET** /orders | 주문 리스트 조회
*OrderApi* | [**order_new**](docs/OrderApi.md#order_new) | **POST** /orders | 주문하기
*OrderApi* | [**order_orderbook**](docs/OrderApi.md#order_orderbook) | **GET** /orderbook | 시세 호가 정보(Orderbook) 조회
*TradeApi* | [**trade_ticker**](docs/TradeApi.md#trade_ticker) | **GET** /ticker | 시세 Ticker 조회
*TradeApi* | [**trade_ticks**](docs/TradeApi.md#trade_ticks) | **GET** /trades/ticks | 시세 체결 조회
*WithdrawApi* | [**withdraw_chance**](docs/WithdrawApi.md#withdraw_chance) | **GET** /withdraws/chance | 출금 가능 정보
*WithdrawApi* | [**withdraw_coin**](docs/WithdrawApi.md#withdraw_coin) | **POST** /withdraws/coin | 코인 출금하기
*WithdrawApi* | [**withdraw_info**](docs/WithdrawApi.md#withdraw_info) | **GET** /withdraw | 개별 출금 조회
*WithdrawApi* | [**withdraw_info_all**](docs/WithdrawApi.md#withdraw_info_all) | **GET** /withdraws | 출금 리스트 조회
*WithdrawApi* | [**withdraw_krw**](docs/WithdrawApi.md#withdraw_krw) | **POST** /withdraws/krw | 원화 출금하기


## Documentation For Models

 - [APIKey](docs/APIKey.md)
 - [Account](docs/Account.md)
 - [Ask](docs/Ask.md)
 - [AskAccount](docs/AskAccount.md)
 - [Bid](docs/Bid.md)
 - [BidAccount](docs/BidAccount.md)
 - [CandleDate](docs/CandleDate.md)
 - [CandleDays](docs/CandleDays.md)
 - [CandleMinutes](docs/CandleMinutes.md)
 - [Currency](docs/Currency.md)
 - [Deposit](docs/Deposit.md)
 - [DepositCompleteResponse](docs/DepositCompleteResponse.md)
 - [DepositTransferResponse](docs/DepositTransferResponse.md)
 - [Error](docs/Error.md)
 - [ErrorInfo](docs/ErrorInfo.md)
 - [Market](docs/Market.md)
 - [MarketInfo](docs/MarketInfo.md)
 - [MemberLevel](docs/MemberLevel.md)
 - [NewOrder](docs/NewOrder.md)
 - [Order](docs/Order.md)
 - [OrderChance](docs/OrderChance.md)
 - [OrderInfo](docs/OrderInfo.md)
 - [Orderbook](docs/Orderbook.md)
 - [OrderbookUnit](docs/OrderbookUnit.md)
 - [Ticker](docs/Ticker.md)
 - [Trade](docs/Trade.md)
 - [TradeTicks](docs/TradeTicks.md)
 - [Wallet](docs/Wallet.md)
 - [Withdraw](docs/Withdraw.md)
 - [WithdrawChance](docs/WithdrawChance.md)
 - [WithdrawCoin](docs/WithdrawCoin.md)
 - [WithdrawLimit](docs/WithdrawLimit.md)


## Documentation For Authorization


## Bearer

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author

ujhin942@gmail.com

