# Upbit Open API
#
# ## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com] 
#
# OpenAPI spec version: 1.0.0
# Contact: ujhin942@gmail.com
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' WithdrawChance Class
#'
#' @field member_level 
#' @field currency 
#' @field account 
#' @field withdraw_limit 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
WithdrawChance <- R6::R6Class(
  'WithdrawChance',
  public = list(
    `member_level` = NULL,
    `currency` = NULL,
    `account` = NULL,
    `withdraw_limit` = NULL,
    initialize = function(`member_level`, `currency`, `account`, `withdraw_limit`){
      if (!missing(`member_level`)) {
        stopifnot(R6::is.R6(`member_level`))
        self$`member_level` <- `member_level`
      }
      if (!missing(`currency`)) {
        stopifnot(R6::is.R6(`currency`))
        self$`currency` <- `currency`
      }
      if (!missing(`account`)) {
        stopifnot(R6::is.R6(`account`))
        self$`account` <- `account`
      }
      if (!missing(`withdraw_limit`)) {
        stopifnot(R6::is.R6(`withdraw_limit`))
        self$`withdraw_limit` <- `withdraw_limit`
      }
    },
    toJSON = function() {
      WithdrawChanceObject <- list()
      if (!is.null(self$`member_level`)) {
        WithdrawChanceObject[['member_level']] <- self$`member_level`$toJSON()
      }
      if (!is.null(self$`currency`)) {
        WithdrawChanceObject[['currency']] <- self$`currency`$toJSON()
      }
      if (!is.null(self$`account`)) {
        WithdrawChanceObject[['account']] <- self$`account`$toJSON()
      }
      if (!is.null(self$`withdraw_limit`)) {
        WithdrawChanceObject[['withdraw_limit']] <- self$`withdraw_limit`$toJSON()
      }

      WithdrawChanceObject
    },
    fromJSON = function(WithdrawChanceJson) {
      WithdrawChanceObject <- jsonlite::fromJSON(WithdrawChanceJson)
      if (!is.null(WithdrawChanceObject$`member_level`)) {
        member_levelObject <- MemberLevel$new()
        member_levelObject$fromJSON(jsonlite::toJSON(WithdrawChanceObject$member_level, auto_unbox = TRUE))
        self$`member_level` <- member_levelObject
      }
      if (!is.null(WithdrawChanceObject$`currency`)) {
        currencyObject <- Currency$new()
        currencyObject$fromJSON(jsonlite::toJSON(WithdrawChanceObject$currency, auto_unbox = TRUE))
        self$`currency` <- currencyObject
      }
      if (!is.null(WithdrawChanceObject$`account`)) {
        accountObject <- Account$new()
        accountObject$fromJSON(jsonlite::toJSON(WithdrawChanceObject$account, auto_unbox = TRUE))
        self$`account` <- accountObject
      }
      if (!is.null(WithdrawChanceObject$`withdraw_limit`)) {
        withdraw_limitObject <- WithdrawLimit$new()
        withdraw_limitObject$fromJSON(jsonlite::toJSON(WithdrawChanceObject$withdraw_limit, auto_unbox = TRUE))
        self$`withdraw_limit` <- withdraw_limitObject
      }
    },
    toJSONString = function() {
       sprintf(
        '{
           "member_level": %s,
           "currency": %s,
           "account": %s,
           "withdraw_limit": %s
        }',
        self$`member_level`$toJSON(),
        self$`currency`$toJSON(),
        self$`account`$toJSON(),
        self$`withdraw_limit`$toJSON()
      )
    },
    fromJSONString = function(WithdrawChanceJson) {
      WithdrawChanceObject <- jsonlite::fromJSON(WithdrawChanceJson)
      MemberLevelObject <- MemberLevel$new()
      self$`member_level` <- MemberLevelObject$fromJSON(jsonlite::toJSON(WithdrawChanceObject$member_level, auto_unbox = TRUE))
      CurrencyObject <- Currency$new()
      self$`currency` <- CurrencyObject$fromJSON(jsonlite::toJSON(WithdrawChanceObject$currency, auto_unbox = TRUE))
      AccountObject <- Account$new()
      self$`account` <- AccountObject$fromJSON(jsonlite::toJSON(WithdrawChanceObject$account, auto_unbox = TRUE))
      WithdrawLimitObject <- WithdrawLimit$new()
      self$`withdraw_limit` <- WithdrawLimitObject$fromJSON(jsonlite::toJSON(WithdrawChanceObject$withdraw_limit, auto_unbox = TRUE))
    }
  )
)
